// Code generated by go-swagger; DO NOT EDIT.

//
// Copyright 2021 The Sigstore Authors.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package timestamp

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/sigstore/rekor/pkg/generated/models"
)

// TimestampResponseReader is a Reader for the TimestampResponse structure.
type TimestampResponseReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *TimestampResponseReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewTimestampResponseOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 400:
		result := NewTimestampResponseBadRequest()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewTimestampResponseDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewTimestampResponseOK creates a TimestampResponseOK with default headers values
func NewTimestampResponseOK() *TimestampResponseOK {
	return &TimestampResponseOK{}
}

/* TimestampResponseOK describes a response with status code 200, with default header values.

Returns a timestamp response
*/
type TimestampResponseOK struct {
	Payload *models.TimestampResponse
}

func (o *TimestampResponseOK) Error() string {
	return fmt.Sprintf("[POST /api/v1/tsr][%d] timestampResponseOK  %+v", 200, o.Payload)
}
func (o *TimestampResponseOK) GetPayload() *models.TimestampResponse {
	return o.Payload
}

func (o *TimestampResponseOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.TimestampResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewTimestampResponseBadRequest creates a TimestampResponseBadRequest with default headers values
func NewTimestampResponseBadRequest() *TimestampResponseBadRequest {
	return &TimestampResponseBadRequest{}
}

/* TimestampResponseBadRequest describes a response with status code 400, with default header values.

The content supplied to the server was invalid
*/
type TimestampResponseBadRequest struct {
	Payload *models.Error
}

func (o *TimestampResponseBadRequest) Error() string {
	return fmt.Sprintf("[POST /api/v1/tsr][%d] timestampResponseBadRequest  %+v", 400, o.Payload)
}
func (o *TimestampResponseBadRequest) GetPayload() *models.Error {
	return o.Payload
}

func (o *TimestampResponseBadRequest) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewTimestampResponseDefault creates a TimestampResponseDefault with default headers values
func NewTimestampResponseDefault(code int) *TimestampResponseDefault {
	return &TimestampResponseDefault{
		_statusCode: code,
	}
}

/* TimestampResponseDefault describes a response with status code -1, with default header values.

There was an internal error in the server while processing the request
*/
type TimestampResponseDefault struct {
	_statusCode int

	Payload *models.Error
}

// Code gets the status code for the timestamp response default response
func (o *TimestampResponseDefault) Code() int {
	return o._statusCode
}

func (o *TimestampResponseDefault) Error() string {
	return fmt.Sprintf("[POST /api/v1/tsr][%d] timestampResponse default  %+v", o._statusCode, o.Payload)
}
func (o *TimestampResponseDefault) GetPayload() *models.Error {
	return o.Payload
}

func (o *TimestampResponseDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
