// Code generated by go-swagger; DO NOT EDIT.

//
// Copyright 2021 The Sigstore Authors.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package timestamp

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/sigstore/rekor/pkg/generated/models"
)

// TimestampResponseOKCode is the HTTP code returned for type TimestampResponseOK
const TimestampResponseOKCode int = 200

/*TimestampResponseOK Returns a timestamp response

swagger:response timestampResponseOK
*/
type TimestampResponseOK struct {

	/*
	  In: Body
	*/
	Payload *models.TimestampResponse `json:"body,omitempty"`
}

// NewTimestampResponseOK creates TimestampResponseOK with default headers values
func NewTimestampResponseOK() *TimestampResponseOK {

	return &TimestampResponseOK{}
}

// WithPayload adds the payload to the timestamp response o k response
func (o *TimestampResponseOK) WithPayload(payload *models.TimestampResponse) *TimestampResponseOK {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the timestamp response o k response
func (o *TimestampResponseOK) SetPayload(payload *models.TimestampResponse) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *TimestampResponseOK) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(200)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// TimestampResponseBadRequestCode is the HTTP code returned for type TimestampResponseBadRequest
const TimestampResponseBadRequestCode int = 400

/*TimestampResponseBadRequest The content supplied to the server was invalid

swagger:response timestampResponseBadRequest
*/
type TimestampResponseBadRequest struct {

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewTimestampResponseBadRequest creates TimestampResponseBadRequest with default headers values
func NewTimestampResponseBadRequest() *TimestampResponseBadRequest {

	return &TimestampResponseBadRequest{}
}

// WithPayload adds the payload to the timestamp response bad request response
func (o *TimestampResponseBadRequest) WithPayload(payload *models.Error) *TimestampResponseBadRequest {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the timestamp response bad request response
func (o *TimestampResponseBadRequest) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *TimestampResponseBadRequest) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(400)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

/*TimestampResponseDefault There was an internal error in the server while processing the request

swagger:response timestampResponseDefault
*/
type TimestampResponseDefault struct {
	_statusCode int

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewTimestampResponseDefault creates TimestampResponseDefault with default headers values
func NewTimestampResponseDefault(code int) *TimestampResponseDefault {
	if code <= 0 {
		code = 500
	}

	return &TimestampResponseDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the timestamp response default response
func (o *TimestampResponseDefault) WithStatusCode(code int) *TimestampResponseDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the timestamp response default response
func (o *TimestampResponseDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithPayload adds the payload to the timestamp response default response
func (o *TimestampResponseDefault) WithPayload(payload *models.Error) *TimestampResponseDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the timestamp response default response
func (o *TimestampResponseDefault) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *TimestampResponseDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
